function[t] = t0stat(dhat,ghat,m,h);
% function[t] = t0stat(dhat,ghat);
% T0.M computes the T0 statistics in Nielsen and Shimotsu (2004)
%
%										   Katsumi Shimotsu, December 2005
%
%   input:  dhat: 1xp
%           ghat: pxp
%           m,h: scalar
%____________________________________________________________________________

p = length(dhat);
d = diag(diag(ghat));
dinv = inv(d);
s = [eye(p-1) -ones(p-1,1)];
dhat = dhat';
t = m*(s*dhat)'*inv(0.25*s*dinv*(ghat.*ghat)*dinv*s' + h*eye(p-1))*s*dhat;
